org.apache.struts2.interceptor.csp

## Class CspInterceptor

- java.lang.Object
- - com.opensymphony.xwork2.interceptor.AbstractInterceptor
  - - org.apache.struts2.interceptor.csp.CspInterceptor

- All Implemented Interfaces:
    ConditionalInterceptor, Interceptor, PreResultListener, Serializable

      public final class CspInterceptor
      extends AbstractInterceptor
      implements PreResultListener

  Interceptor that implements Content Security Policy on incoming requests used to protect against common XSS and data injection attacks. Uses `CspSettings` to add appropriate Content Security Policy header to the response. These headers determine what the browser will consider a policy violation and the browser's behavior when a violation occurs. A detailed explanation of CSP can be found here.
  See Also:
    https://csp.withgoogle.com/docs/index.html/, `CspSettings`, `DefaultCspSettings`, Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CspInterceptor()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `beforeResult(ActionInvocation invocation, String resultCode)` This callback method will be called after the `Action` execution and before the `Result` execution.
    `String` | `intercept(ActionInvocation invocation)` Override to handle interception
    `void` | `setEnforcingMode(String value)`
    `void` | `setReportUri(String reportUri)`

    - ### Methods inherited from class com.opensymphony.xwork2.interceptor.AbstractInterceptor

      `destroy, init, setDisabled, shouldIntercept`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CspInterceptor

          public CspInterceptor()

  - ### Method Detail

    - #### intercept

          public String intercept(ActionInvocation invocation)
                           throws Exception

      Description copied from class: `AbstractInterceptor`
      Override to handle interception
      Specified by:
        `intercept` in interface `Interceptor`
      Specified by:
        `intercept` in class `AbstractInterceptor`
      Parameters:
        `invocation` - the action invocation
      Returns:
        the return code, either returned from `ActionInvocation.invoke()`, or from the interceptor itself.
      Throws:
        `Exception` - any system-level error, as defined in `Action.execute()`.

    - #### beforeResult

          public void beforeResult(ActionInvocation invocation,
                                   String resultCode)

      Description copied from interface: `PreResultListener`
      This callback method will be called after the `Action` execution and before the `Result` execution.
      Specified by:
        `beforeResult` in interface `PreResultListener`
      Parameters:
        `invocation` - the action invocation
        `resultCode` - the result code returned by the action (eg. `success`).

    - #### setReportUri

          public void setReportUri(String reportUri)

    - #### setEnforcingMode

          public void setEnforcingMode(String value)

Copyright © 2000–2023 Apache Software Foundation. All rights reserved.